% Figure3_2.m
% It requires the following functions:
% phiAh
% phiBh
% phiCh
% phiSnABC
% phiSnABCproc
% fABC.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global A B C
for is=1:2
    if is==1
        A=1; B=2; C=3;
    else
        A=0; B=2; C=3;
    end
%%%%%%%%%%%%%  ABC-flow   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time
t0=0;  tf=20; 
% Initial Conditions 
x0 = [1 ; 2; 3];  x=[];
% Computing the numerical "exact" solution
  options = odeset('AbsTol',1e-15,'RelTol',1e-13);
  [t,x] = ode45('fABC',[t0,tf],x0,options);
  
for imet=1:5
erEnS=[]; erPosS=[]; costS=[];
   t=[]; xs=[];
    if imet==1
%  Coefficients of the PS_3^[4] method of Blanes-Casas-Ros, SISC(99)
nstages=4;
a1=(57+sqrt(18069))/300;
a=[a1,1/2-a1,1/2-a1,a1];
b1=6/25; b2=-1/10; 
b=[b1,b2,1-2*(b1+b2),b2,b1];
ga(1)=b(1);
ga(2)=a(1)-ga(1);
for i=2:4;
    ga(2*i-1)=b(i)-ga(2*i-2);
    ga(2*i)=a(i)-ga(2*i-1);
end

np=4;
z1=-0.1171835753202670; z2=0.8785444960116207; z3=-0.8972532123604465;
z4=-(z1+z2+z3);
y1=-0.5903105192555323; y2=0.00137327945651155115; y3=0.3958521503201655;
y4=-(y1+y2+y3);
z=-[z1, z2, z3, z4];
y=-[y1, y2, y3, y4];

  ga(1)=b(1);  gp(1)=0;
  ga(2)=a(1)-ga(1); gp(2)=z(1)-gp(1)
  for i=2:4;
    ga(2*i-1)=b(i)-ga(2*i-2);
    ga(2*i)=a(i)-ga(2*i-1);
     gp(2*i-1)=y(i-1)-gp(2*i-2);
     gp(2*i)=z(i)-gp(2*i-1);
  end
    elseif imet==2
  nstages=3;
  a1=1/(2-2^(1/3));
  al=[a1, 1-2*a1, a1];

    elseif imet==3
%  Coefficients of the SS_5^[4] method of Suzuki
 nstages=5;
a1=1/(4-4^(1/3));
al=[a1, a1, 1-4*a1, a1, a1];

    elseif imet==4
%  Coefficients of the S_^[4] method of Blanes&Moan
nstages=6;
a1=0.209515106613362; a2=-0.143851773179818;
a=[a1,a2,1/2-(a1+a2),1/2-(a1+a2),a2,a1];
b1=0.07920369643119565; b2=0.353172906049774; b3=-0.04206508035771952;
b=[b1,b2,b3,1-2*(b1+b2+b3),b3,b2,b1];
ga(1)=b(1);
ga(2)=a(1)-ga(1);
for i=2:6;
    ga(2*i-1)=b(i)-ga(2*i-2);
    ga(2*i)=a(i)-ga(2*i-1);
end
    end
  
for i=1:8
   t=[]; xk1=[];    xk2=[];    xk4=[]; 
   N=3*2^i;  h = (tf-t0)/N;
if imet==1
   [t xs]=phiSnABCproc(t0,tf,x0,N,ga,nstages,gp,np);
elseif imet==2||imet==3
   [t xs]=phiSSnABC(t0,tf,x0,N,al,nstages);
else
   [t xs]=phiSnABC(t0,tf,x0,N,ga,nstages);
end

   erEnS=[erEnS; norm(x(end,:)-xs(end,:))]; costS=[costS; nstages*N];
end

figure(2)
subplot(1,2,is)
hold on
  if imet==1
       plot(log10(costS),log10(erEnS(:)),'--k','LineWidth',1.5)
%       text(2.9,-5.5,'PS_{4}^{[4]}','FontSize',14)
 elseif imet==2
        plot(log10(costS),log10(erEnS(:)),':k','LineWidth',1.5)
%       text(3.4,-3.8,'SS_{3}^{[4]}','FontSize',14)
  elseif imet==3
        plot(log10(costS),log10(erEnS(:)),'-sk','LineWidth',1.5)
%      text(2.4,-2.8,'SS_{5}^{[4]}','FontSize',14)
  elseif imet==4
        plot(log10(costS),log10(erEnS(:)),'-dk','LineWidth',1.5)
%       text(3.6,-7,'S_{6}^{[4]}','FontSize',14)
  end
  axis([1.8 3.2 -4 1]) 
  xlabel('{\fontsize{14} log_{10}(N. eval.) }')   
  ylabel('{\fontsize{14} log_{10}(Error)}')   
  title('{\fontsize{14} ABC-flow}')   
  box
end
end

