%             phiSnABC.m
% s-stage Splitting method.
% fA, fB: flows associated to the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t x] = phiSnABC(t0,tf,x0,N,al,s)
% coefficients of the problem
global A B C
h = (tf-t0)/N;
ah=h*al;
t=t0:h:tf; x=x0';  y=x0;
for i=1:N;
    for j=1:s;
        y = phiAh(y,ah(2*j-1),A);
        y = phiBh(y,ah(2*j-1),B);
            aah=ah(2*j)+ah(2*j-1);
        y = phiCh(y,aah,C);
        y = phiBh(y,ah(2*j),B);
        y = phiAh(y,ah(2*j),A);

    end
x = [x ; y ];
end
end

