%             phiSnABCproc.m
% s-stage Splitting method.
% fA, fB: flows associated to the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t x] = phiSnABCproc(t0,tf,x0,N,al,s,ga,np)
global A B C
% coefficients of the problem
%A=1; B=2; C=3;
h = (tf-t0)/N;
ah=h*al;gh=h*ga;
t=t0:h:tf; x=x0';  y=x0;
    for j=1:np;
        y = phiAh(y,gh(2*j-1),A);
        y = phiBh(y,gh(2*j-1),B);
            ggh=gh(2*j)+gh(2*j-1);
        y = phiCh(y,ggh,C);
        y = phiBh(y,gh(2*j),B);
        y = phiAh(y,gh(2*j),A);
    end
for i=1:N;
    for j=1:s;
        y = phiAh(y,ah(2*j-1),A);
        y = phiBh(y,ah(2*j-1),B);
            aah=ah(2*j)+ah(2*j-1);
        y = phiCh(y,aah,C);
        y = phiBh(y,ah(2*j),B);
        y = phiAh(y,ah(2*j),A);

    end
end
    for j=np:-1:1;
        y = phiAh(y,-gh(2*j),A);
        y = phiBh(y,-gh(2*j),B);
            ggh=gh(2*j)+gh(2*j-1);
        y = phiCh(y,-ggh,C);
        y = phiBh(y,-gh(2*j-1),B);
        y = phiAh(y,-gh(2*j-1),A);
    end

x = [x ; y ];
end

